
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.mcoding.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;
import net.neoforged.neoforge.capabilities.RegisterCapabilitiesEvent;
import net.neoforged.neoforge.capabilities.Capabilities;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.Block;
import net.minecraft.core.registries.BuiltInRegistries;

import net.mcreator.mcoding.block.entity.PlaceBlockEntity;
import net.mcreator.mcoding.block.entity.MessageBlockEntity;
import net.mcreator.mcoding.block.entity.CustomActionBlockEntity;
import net.mcreator.mcoding.McodingMod;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public class McodingModBlockEntities {
	public static final DeferredRegister<BlockEntityType<?>> REGISTRY = DeferredRegister.create(BuiltInRegistries.BLOCK_ENTITY_TYPE, McodingMod.MODID);
	public static final DeferredHolder<BlockEntityType<?>, BlockEntityType<?>> PLACE = register("place", McodingModBlocks.PLACE, PlaceBlockEntity::new);
	public static final DeferredHolder<BlockEntityType<?>, BlockEntityType<?>> MESSAGE = register("message", McodingModBlocks.MESSAGE, MessageBlockEntity::new);
	public static final DeferredHolder<BlockEntityType<?>, BlockEntityType<?>> CUSTOM_ACTION = register("custom_action", McodingModBlocks.CUSTOM_ACTION, CustomActionBlockEntity::new);

	// Start of user code block custom block entities
	// End of user code block custom block entities
	private static DeferredHolder<BlockEntityType<?>, BlockEntityType<?>> register(String registryname, DeferredHolder<Block, Block> block, BlockEntityType.BlockEntitySupplier<?> supplier) {
		return REGISTRY.register(registryname, () -> BlockEntityType.Builder.of(supplier, block.get()).build(null));
	}

	@SubscribeEvent
	public static void registerCapabilities(RegisterCapabilitiesEvent event) {
		event.registerBlockEntity(Capabilities.ItemHandler.BLOCK, PLACE.get(), (blockEntity, side) -> ((PlaceBlockEntity) blockEntity).getItemHandler());
		event.registerBlockEntity(Capabilities.ItemHandler.BLOCK, MESSAGE.get(), (blockEntity, side) -> ((MessageBlockEntity) blockEntity).getItemHandler());
		event.registerBlockEntity(Capabilities.ItemHandler.BLOCK, CUSTOM_ACTION.get(), (blockEntity, side) -> ((CustomActionBlockEntity) blockEntity).getItemHandler());
	}
}
