package net.mcreator.mcoding.procedures;

import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.network.chat.Component;
import net.minecraft.core.BlockPos;

import net.mcreator.mcoding.init.McodingModGameRules;
import net.mcreator.mcoding.McodingMod;

public class SignalBlockAddedProcedure {
	public static void execute(LevelAccessor world, double x, double y, double z) {
		if (world.getLevelData().getGameRules().getBoolean(McodingModGameRules.DEBUG_MESSAGES)) {
			if (!world.isClientSide() && world.getServer() != null)
				world.getServer().getPlayerList().broadcastSystemMessage(Component.literal("Signal: Created"), false);
		}
		McodingMod.queueServerWork(1, () -> {
			world.setBlock(BlockPos.containing(x, y, z), Blocks.AIR.defaultBlockState(), 3);
			if (world.getLevelData().getGameRules().getBoolean(McodingModGameRules.DEBUG_MESSAGES)) {
				if (!world.isClientSide() && world.getServer() != null)
					world.getServer().getPlayerList().broadcastSystemMessage(Component.literal("Signal: Deleting"), false);
			}
		});
	}
}
